(function (global) {
    "use strict";

    global.ND = global.ND || {};
    global.ND.Portal = global.ND.Portal || {};
    global.ND.Portal.Forms = (function () {

        const hideSections = (sectionName) => {
            $(`fieldset[aria-label="${sectionName}"]`).hide();
            $("#AttachFile").parent().parent().hide();
        };

        const showSections = (sectionName) => {
            $(`fieldset[aria-label="${sectionName}"]`).show();
            //$("#AttachFile").parent().parent().show();        
        };

        const removeFieldIfBlank = (field) => {
            if (!$(`#${field}`).val()) {
                $(`#${field}`).parents('td').remove();
            }
        }

        var addLookupButtons = (fieldId, modalId) => {
            $(`#${fieldId}_entityname`).after(`
				<div class="input-group-btn" style="">
					<button id="clear-${fieldId}" type="button" class="hidden clear-btn btn btn-primary ml-1 mr-1">
						<span class="sr-only">Launch lookup modal</span>
						<span class="glyphicon glyphicon-remove" aria-hidden="true"></span>
					</button>
					<button schemaName="${fieldId}" type="button" data-toggle="modal" data-target="#${modalId}" class="ml-1 btn btn-primary">
						<span class="sr-only">Launch lookup modal</span>
						<span class="fa fa-search" aria-hidden="true"></span>
					</button>
				</div>
			`);

            if ($(`#${fieldId}`).val()) {
                $(`#clear-${fieldId}`).removeClass("hidden");
            }
            
            $(`#${fieldId}_name`).on('keydown keypress keyup input', function (e) {
                if (e.key !== 'Tab' && e.keyCode !== 9) {
                    event.preventDefault();
                }
            }).on('mousedown', function (event) {
                // Prevent mouse-based interactions such as selecting text or right-clicking to delete
                event.preventDefault();
            });

            $(`#${fieldId}_name`)
                .attr('data-toggle', 'modal')
                .attr('data-target', `#${modalId}`)
                .attr('schemaname', fieldId);
        }

        var clonePortalDataToSelectionCounts = () => {
            var portalData = JSON.parse($("#ndland_portaldata").val() || '{}');
            if (!portalData || !portalData?.intersects) {
                return;
            }
            portalData.intersects.forEach(item => {
                // Check if a count record already exists for this item
                const countRecordName = item.intersectLogicalName + 'count';
                const countRecordExists = portalData.intersects.some(intersect => intersect.intersectLogicalName === countRecordName);

                // If the count record doesn't exist, create it
                if (!countRecordExists) {
                    // Create a new count record with the same records array
                    portalData.intersects.push({
                        intersectLogicalName: countRecordName,
                        records: item.records
                    });
                }
            });
            $("#ndland_portaldata").val(JSON.stringify(portalData));
        }

        var populateLookupName = (lookupName, id, name, entityLogicalName) => {
            //populatelookup
            if (id && name && entityLogicalName) {
                $(`#${lookupName}_name`).val(name);
                $(`#${lookupName}`).val(id);
                $(`#${lookupName}_entityname`).val(entityLogicalName);
                $(`#clear-${lookupName}`).removeClass("hidden");
                if (lookupName == "ndland_rightofwayid") {
                    showSections("Tracts for Amendment");
                    showSections("Related Tracts");
                    showSections("Project Details");
                    showSections("Release Type");
                    showSections("Amendment Details");
                    showSections("Contacts");
                    showSections("Documents");
                    showSections("Other Comments");
                }
            //clear lookup
            } else if (!entityLogicalName){
                $(`#${lookupName}_name`).val(null);
                $(`#${lookupName}`).val(null);
                $(`#${lookupName}_entityname`).val(null);
                $(`#clear-${lookupName}`).addClass("hidden");
                if (lookupName == "ndland_rightofwayid") {
                    hideSections("Tracts for Amendment");
                    hideSections("Related Tracts");
                    hideSections("Project Details");
                    hideSections("Release Type");
                    hideSections("Amendment Details");
                    hideSections("Contacts");
                    hideSections("Documents");
                    hideSections("Other Comments");
                }
            }
            _id = null;
            _name = null;
        }

        const handleLookupPopulation = (tableId, entityLogicalName) => {
            const lookupName = $(`#${tableId}`).attr("currentlookupvalue");
            populateLookupName(lookupName, _id, _name, entityLogicalName);
        };

        const initialApplicationFormFieldValues = {};
        var addSubmissionValidation = (applicationId, userId, validators, validResultCallback, applicationType, removedDocuments) => {
            // Store initial values of the application form fields
            initializeFormValues();
            var confirmSubmissionButton = $('<input data-toggle="modal" data-target="#confirm-submission-modal" type="button" name="ctl00$ContentContainer$EntityFormControl_724af79d946fef11a671001dd80a75b5$ConfirmButton" value="Submit Application" id="ConfirmSubmissionButton" class="submit-btn btn btn-primary form-action-container-left">');
            $('input.submit-btn.btn.btn-primary.form-action-container-left[value="Submit"]').replaceWith(confirmSubmissionButton);
            $('div.actions').each(function () {
                if (!$(this).hasClass('buttons-stacked-breakpoint-xs-and-under')) {
                    $(this).addClass('buttons-stacked-breakpoint-xs-and-under');
                }
            });
            if (validators.length > 0) {
                Page_Validators.unshift(...validators);
            }

            let validatorId = "termsValidator";
            let validatorIndex = Page_Validators.findIndex(validator => validator.id === validatorId);
            if (validatorIndex !== -1) {
                let [validator] = Page_Validators.splice(validatorIndex, 1);
                Page_Validators.push(validator);
            }

            let lesseeValidatorId = "lesseeValidator";
            let reserveVolumeValidatorId = "RequiredFieldValidatorndland_aggregateleasetotalreservevolume";

            let lesseeValidatorIndex = Page_Validators.findIndex(validator => validator.id === lesseeValidatorId);
            let reserveVolumeValidatorIndex = Page_Validators.findIndex(validator => validator.id === reserveVolumeValidatorId);

            if (lesseeValidatorIndex !== -1 && reserveVolumeValidatorIndex !== -1) {
                Page_Validators.splice(reserveVolumeValidatorIndex + 1, 0, Page_Validators.splice(lesseeValidatorIndex, 1)[0]);
            }

            let dateTreatedValidatorId = "RequiredFieldValidatorndland_datetreated";
            let weedAndPestValidatorReimbursementId = "weedAndPestTypeReimbursementValidator";
            let dateTreatedValidatorIndex = Page_Validators.findIndex(validator => validator.id === dateTreatedValidatorId);
            let weedAndPestValidatorReimbursementIndex = Page_Validators.findIndex(validator => validator.id === weedAndPestValidatorReimbursementId);

            if (dateTreatedValidatorIndex !== -1 && weedAndPestValidatorReimbursementIndex !== -1) {
                let [dateTreatedValidator] = Page_Validators.splice(dateTreatedValidatorIndex, 1);
                Page_Validators.splice(weedAndPestValidatorReimbursementIndex, 0, dateTreatedValidator);
            }

            let assigneeValidatorId = "assigneeValidatorConsentToAssignment";
            let assigneeValidatorIndex = Page_Validators.findIndex(validator => validator.id === assigneeValidatorId);
            if (assigneeValidatorIndex !== -1) {
                Page_Validators.push(Page_Validators.splice(assigneeValidatorIndex, 1)[0]);
            }

            let percentTotalConsentToAssignmentIndex = Page_Validators.findIndex(v => v.id === 'percentTotalValidator');
            if (percentTotalConsentToAssignmentIndex !== -1) {
                let percentTotalConsentToAssignment = Page_Validators.splice(percentTotalConsentToAssignmentIndex, 1)[0];
                Page_Validators.push(percentTotalConsentToAssignment);
            }

            let submitButton = $('#SubmitButton');
            submitButton.val('Submit Application');
            $("#ConfirmSubmissionButton").before(`<input type="button" name="ctl00$ContentContainer$EntityFormControl_3d3e0e62652eef11840a001dd808b262$UpdateButton" value="Save Draft" onclick="" id="SaveButtonForm" title="Submit" class="mr-1 btn btn-default button submit-btn">`);
            submitButton.attr("onclick", "").unbind("click");
            submitButton.attr('onclick', '').on('click', (e) => {
                $('.validation-summary').hide();
                $('#application-save-success').remove();
                $('td.has-error').removeClass('has-error');
                $("#formLoaderLoadingText").text("Submitting application...");
                let validationResult = Page_ClientValidate();
                if (typeof entityFormClientValidate === 'function') {
                    if (entityFormClientValidate()) {
                        if (typeof Page_ClientValidate === 'function') {
                            if (Page_ClientValidate('')) {
                                clearIsDirty();
                                disableButtons();
                            } else {
                                $('html, body').animate({ scrollTop: 0 }, 'fast');
                            }
                        } else {
                            clearIsDirty();
                            disableButtons();
                        }
                    } else {
                        return false;
                    }
                } else {
                    if (typeof Page_ClientValidate === 'function') {
                        if (Page_ClientValidate('')) {
                            clearIsDirty();
                            disableButtons();
                        }
                    } else {
                        clearIsDirty();
                        disableButtons();
                    }
                };
                if (validationResult) {
                    if (validResultCallback) {
                        // Optional way to add any additional logic once the all sections have been validated
                        validResultCallback();
                    }
                    var currentUrl = window.location.href;
                    var url = new URL(currentUrl);
                    var id = url.searchParams.get('id');
                    saveApplicationAsSubmitted(userId, id, applicationType, removedDocuments);
                } else {
                    const inputs = document.querySelectorAll('input[type="submit"], input[type="button"]');
                    inputs.forEach(input => input.disabled = false);
                    $(".validation-summary").find("ul li a").each(function () {
                        const label = `${$(this).attr("referencecontrolid")}_label`;
                        $(`#${label}`).closest('td').addClass("has-error");
                    })
                }
            });
            let withdrawButton = $('#withdraw-submission-submit-btn');
            withdrawButton.attr("onclick", "").unbind("click");
            withdrawButton.attr('onclick', '').on('click', (e) => {

                $("#formLoaderLoadingText").text("Withdrawing application...");
                disableButtons();
                saveApplicationAsWithdrawn(userId, applicationId, applicationType);

            });
            let saveButton = $('#SaveButtonForm');
            saveButton.attr("onclick", "").unbind("click");
            saveButton.attr('onclick', '').on('click', (e) => {
                var statusText = $("dt:contains('Status')").next("dd").text().trim();
                const isSubmitted = statusText.contains("Submitted");
                var notificationText = "";
                if (isSubmitted) {
                    $("#formLoaderLoadingText").text("Saving submission...");
                    notificationText = "Application";
                } else {
                    $("#formLoaderLoadingText").text("Saving draft...");
                    notificationText = "Application draft";
                }
                //disableButtons();
                $('.validation-summary').hide();
                $('#application-save-success').remove();
                $('.alert:visible').not('.m-0').hide();
                $('.has-error').removeClass('has-error');
                $('<div id="application-save-success" class="alert alert-dismissable alert-success vertically-align">' +
                    '<button type="button" class="close" data-dismiss="alert">×</button>' +
                    `<p>${notificationText} has been saved successfully.</p>` +
                    '</div>').prependTo('.body-content .container');
                $('html, body').animate({ scrollTop: 0 }, 'fast');
                var currentUrl = window.location.href;
                var url = new URL(currentUrl);
                var id = url.searchParams.get('id');
                saveApplicationAsDraft(userId, id, applicationType, removedDocuments);
            });
        }

        var _addFieldChangeToPayload = (payload, key, value, id) => {
            var isValueClearedOrUpdated = 
            initialApplicationFormFieldValues[key] && initialApplicationFormFieldValues[key] !== value;
            var isLookupClearedOrUpdated = null;
            var isLookupCleared = null;
            var isDateReset = key.includes("date") && value === "";
            var lookupSchemaNameKey = "";
            if (key.includes("@odata.bind")) {
                if (key.includes("account@odata.bind") || key.includes("contact@odata.bind")) {
                    lookupSchemaNameKey = key.replace(/(account|contact)@odata\.bind$/, "name").toLowerCase();
                } else {
                    lookupSchemaNameKey = key.replace("@odata.bind", "_name").toLowerCase();
                }
                isLookupClearedOrUpdated = initialApplicationFormFieldValues[lookupSchemaNameKey] && initialApplicationFormFieldValues[lookupSchemaNameKey] !== value;
                isLookupCleared = isLookupClearedOrUpdated && value === "/s()";
            }
            if ((value || isValueClearedOrUpdated) && key && (id || isLookupClearedOrUpdated) && (!value.toString().includes("placeholder"))) {
                if (isDateReset) {
                    payload[key] = null;
                }
                else if (isLookupCleared) {
                    payload[key.replace("@odata.bind", "")] = null;
                } else {
                    payload[key] = value;
                }
            }

            var includeValueInUpdate = 
                (value || isValueClearedOrUpdated) && 
                key && 
                (id || isLookupClearedOrUpdated) && 
                (!value.toString().includes("placeholder"));

            if (includeValueInUpdate) {
                if (isDateReset) {
                    payload[key] = null;
                } else if (isLookupCleared) {
                    payload[key.replace("@odata.bind", "")] = null;
                } else {
                    payload[key] = value;
                }
            }
        }

        var _handleApplicationFileSave = async (applicationId) => {
            if (!$("#file-data-hdn").val()?.length > 0) {
                return;
            }
            const fileInput = JSON.parse($("#file-data-hdn").val());
            if (!fileInput || fileInput.length === 0) {
                return;
            }

            for (let i = 0; i < fileInput.length; i++) {
                const file = fileInput[i];
                const fileName = file.name;
                const mimeType = file.type;

                const base64Content = file.base64Content;
                const note = {
                    "objectid_eyland_application@odata.bind": `/eyland_applications(${applicationId})`,
                    "objecttypecode": "eyland_application",
                    "subject": fileName,
                    "filename": fileName,
                    "documentbody": base64Content,
                    "mimetype": mimeType
                };

                await ND.Portal.API.appAjax('Saving record...', {
                    type: "POST",
                    url: "/_api/annotations",
                    contentType: "application/json",
                    data: JSON.stringify(note),
                    success: function (res, status, xhr) {
                        console.log(`File ${fileName} uploaded successfully.`);
                        ND.Portal.Tables.handlePageToggle(1, 1, "documents", _createDocumentsRow, "ND Service: Get Application ROW Documents");
                        //$(`#${fileName.replaceAll(/[ .()]/g, "")} #remove-document-btn`).attr("data-islocal", false);
                        //$(`#${fileName.replaceAll(/[ .()]/g, "")}`).attr("id", xhr.getResponseHeader('EntityId'));
                    },
                    error: function (xhr, status, error) {
                        const errorMessage = xhr.status + ': ' + xhr.statusText;
                        console.log(`Error uploading file ${fileName}: `, errorMessage);
                    }
                });
            }
            $("#file-data-hdn").val(JSON.stringify(null));
        };

        var _handleApplicationFileDelete = async (noteId) => {
            if (!noteId) {
                return;
            }
            return new Promise((resolve, reject) => {
                ND.Portal.API.appAjax('Deleting record...', {
                    type: "DELETE",
                    url: `/_api/ndland_filenetuploads(${noteId})`,
                    success: function (res, status, xhr) {
                        console.log('Note deleted successfully.');
                        resolve();
                    },
                    error: function (xhr, status, error) {
                        var errorMessage = xhr.status + ': ' + xhr.statusText;
                        console.log(errorMessage);
                        reject(errorMessage);
                    }
                });
            });
        };

        var buildPayload = (contactId, applicationType) => {
            let payload = {};


            let mineralApplicationType = JSON.parse($("#ndland_portaldata").val() || '{}').applicationType;
            if (mineralApplicationType === "New Lease") {
                mineralApplicationType = 769150000;
            } else if (mineralApplicationType === "Lease Amendment") {
                mineralApplicationType = 769150001;
            } else if (mineralApplicationType === "Lease Assignment") {
                mineralApplicationType = 769150002;
            } else if (mineralApplicationType === "Lease Extension") {
                mineralApplicationType = 769150003;
            } else if (mineralApplicationType === "Lease Termination") {
                mineralApplicationType = 769150004;
            }
            let improvementTypeId = $('#ndland_improvementtypeid option:selected').attr("id");
            let poolName = $("#ndland_poolname").val();
            let abandonmentPlans = $("#ndland_abandonmentplans").val();
            let nominatorKey = $("#ndland_nominatorid_entityname").val() == "account" ? "ndland_NominatorId_account@odata.bind" : "ndland_NominatorId_contact@odata.bind";
            let requestedOnBehalfOfKey = $("#ndland_requestedonbehalfofid_entityname").val() == "account" ? "ndland_RequestedonBehalfOfId_account@odata.bind" : "ndland_RequestedonBehalfOfId_contact@odata.bind";
            let assignorKey = $("#ndland_assignorid_entityname").val() == "account" ? "ndland_AssignorId_account@odata.bind" : "ndland_AssignorId_contact@odata.bind";
            let finalDocumentRecipientKey = $("#ndland_finaldocumenttobemailedtoid_entityname").val() == "account" ? "ndland_FinalDocumentToBeMailedToId_account@odata.bind" : "ndland_FinalDocumentToBeMailedToId_contact@odata.bind";
            let granteeKey = $("#ndland_granteecustomerid_entityname").val() == "account" ? "ndland_GranteeCustomerId_account@odata.bind" : "ndland_GranteeCustomerId_contact@odata.bind";
            let assigneeKey = $("#ndland_assigneeid_entityname").val() == "account" ? "ndland_AssigneeId_account@odata.bind" : "ndland_AssigneeId_contact@odata.bind";
            
            //for surface mineral application default to account only
            if (applicationType === "bf3eabf9-7956-eb11-a812-001dd801e994") {
                assigneeKey = "ndland_AssigneeId_account@odata.bind";
            }
            let permitteeKey = $("#ndland_permitteeid_entityname").val() == "account" ? "ndland_PermitteeId_account@odata.bind" : "ndland_PermitteeId_contact@odata.bind";
            let surveyKey = $("#ndland_surveyengineeringcustomerid_entityname").val() == "account" ? "ndland_SurveyEngineeringCustomerId_account@odata.bind" : "ndland_SurveyEngineeringCustomerId_contact@odata.bind";
            let projectDescription = $("#ndland_projectdescription").val();
            let projectPurpose = $("#ndland_projectpurpose").val();
            let rightOfWayProjectTimeline = $("#ndland_rightofwayprojecttimeline").val();
            let projectTimeline = $("#ndland_projecttimeline").val();
            let considerationOffer = $("#ndland_considerationoffer").val();
            let permitteeId = $("#ndland_permitteeid").val();
            let nominatorId = $("#ndland_nominatorid").val();
            let leaseAgreementId = $('#ndland_leaseid_dropdown option:selected').attr('id');
            if (!leaseAgreementId) {
                leaseAgreementId = $("#ndland_leaseid option:selected").attr("id");
            }
            let requestedOnBehalfOfId = $("#ndland_requestedonbehalfofid").val();
            let primaryRightOfWayContactId = $("#ndland_primaryrightofwaycontactid").val();
            let finalSignatureContactId = $("#ndland_finalsignaturecontactid").val();
            let constructionSupervisorId = $("#ndland_constructionsupervisorid").val();
            let constructionContractorId = $("#ndland_constructioncontractorid").val();
            let finalDocumentRecipientId = $("#ndland_finaldocumenttobemailedtoid").val();
            let reclamationSupervisorId = $("#ndland_reclamationsupervisorid").val();
            let surveyEngineeringCompanyId = $("#ndland_surveyengineeringcustomerid").val();
            let assignorId = $("#ndland_assignorid").val();
            let requestedById = contactId;
            let assignmentType = $("#ndland_assignmentreason").val() !== "placeholder" ? $("#ndland_assignmentreason").val() : null;
            let portalData = JSON.parse($("#ndland_portaldata").val() || '{}');
            portalData.intersects = portalData?.intersects?.filter(item => !item.intersectLogicalName.includes('count'));//remove count records
            portalData = JSON.stringify(portalData);
            let relationshipToCurrentLessee = $("#ndland_relationshiptocurrentlessee").val();
            let rightOfWayId = $("#ndland_rightofwayid").val();
            let rightOfWayReleaseType = parseInt(($('#ndland_rightofwayreleasetype input[type="radio"]:checked').val()), 10);
            let granteeId = $("#ndland_granteecustomerid").val();
            let estimatedAcres = parseFloat($("#ndland_aggregateleaseestimatedacres").val(), 10);
            let estimatedAcresReserve = parseFloat($("#ndland_aggregateleasetotalreservevolume").val(), 10);
            let spacingDescription = $("#ndland_spacingdescription").val();
            let ndicSpacingOrder = $("#ndland_ndicspacingordernum").val();
            let effectiveStartDate = $("#ndland_effectivestartdate").val();
            let effectiveEndDate = $("#ndland_effectiveenddate").val();
            let expectedLastProductionDate = $("#ndland_expectedlastproductiondate").val();
            let expectedReturnToProductionDate = $("#ndland_expectedreturntoproductiondate").val();
            let numberOfSignsRequested = $("#ndland_numbofsignsrequested").val();
            let signPostTypeId = $('#ndland_signposttypeid_radios input[type="radio"]:checked').val();
            let existingStockWaterDevelopment = $('#ndland_stockwaterdevelopment input[type="radio"]:checked').val() === "1" ? true : false;
            let costShareAssistance = $('#ndland_receiveexternalcostshareassistance input[type="radio"]:checked').val() === "1" ? true : false;
            let laborCalculationMethod = $('#ndland_laborcalculationmethod input[type="radio"]:checked').val();
            let reasonForShutIn = $('#ndland_reasonforshutin').val();
            let termsConditions = false;
            if ($('#ndland_agreetoterms_checkbox').is(':checked')) {
                termsConditions = true;
            }

            let applicationComments = $("#ndland_applicationcomments").val();
            if (applicationType == "38a35554-4f9e-ec11-b3fe-001dd8015833") {
                let apiNum = `API/Unit #: ${$(".apiUnitNumber").val()}`;
                let operator = `Operator: ${$(".operator").val()}`;
                let field = `Field: ${$(".field").val()}`;
                let formation = `Formation: ${$(".formation").val()}`;
                let ndic = `NDIC Spacing and Pooling Order #: ${$(".ndicSpacingAndPooling").val()}`;
                applicationComments = $(".ndland_applicationcomments").last().val();
                if ($(".apiUnitNumber").val()) {
                    applicationComments += `\n${apiNum}`;
                }
                if ($(".operator").val()) {
                    applicationComments += `\n${operator}`;
                }
                if ($(".field").val()) {
                    applicationComments += `\n${field}`;
                }
                if ($(".formation").val()) {
                    applicationComments += `\n${formation}`;
                }
                if ($(".ndicSpacingAndPooling").val()) {
                    applicationComments += `\n${ndic}`;
                }
            }

            let otherAssignees = $("#ndland_otherassignees").val();
            let assigneeId = $("#ndland_assigneeid").val();
            if (applicationType == "95c66e35-7a56-eb11-a812-001dd801e994") {
                var regex = /(Primary Lessee: .+)/;
                if (regex.test(otherAssignees)) {
                    var extractedValue = otherAssignees.match(regex)[1];
                    otherAssignees = otherAssignees.replace(extractedValue, "");
                }
                if (assigneeId) {
                    otherAssignees += `\nPrimary Lessee: ${assigneeId}`;
                }
                assigneeId = null;
            }
            _addFieldChangeToPayload(payload, "ndland_treatmentmethod", $("#ndland_treatmentmethod").val(), true);
            _addFieldChangeToPayload(payload, "ndland_aggregateleaseaction", mineralApplicationType, true);
            _addFieldChangeToPayload(payload, "ndland_stockwaterdevelopmentnotes", $("#ndland_stockwaterdevelopmentnotes").val(), true);
            _addFieldChangeToPayload(payload, "ndland_stockwaterdevelopment", existingStockWaterDevelopment, true);
            _addFieldChangeToPayload(payload, "ndland_laborcalculationmethod", Number(laborCalculationMethod), true);
            _addFieldChangeToPayload(payload, "ndland_receiveexternalcostshareassistancenotes", $("#ndland_receiveexternalcostshareassistancenotes").val(), true);
            _addFieldChangeToPayload(payload, "ndland_receiveexternalcostshareassistance", costShareAssistance, true);
            _addFieldChangeToPayload(payload, "ndland_estimatedimprovementcost", Number($("#ndland_estimatedimprovementcost").val()), true);
            _addFieldChangeToPayload(payload, "ndland_startdate", $("#ndland_startdate").val(), true);
            _addFieldChangeToPayload(payload, "ndland_poolname", poolName, true);
            _addFieldChangeToPayload(payload, "ndland_abandonmentplans", abandonmentPlans, true);
            _addFieldChangeToPayload(payload, "ndland_projectdescription", projectDescription, true);
            _addFieldChangeToPayload(payload, "ndland_projectpurpose", projectPurpose, true);
            _addFieldChangeToPayload(payload, "ndland_rightofwayprojecttimeline", rightOfWayProjectTimeline, true);
            _addFieldChangeToPayload(payload, "ndland_projecttimeline", projectTimeline, true);
            _addFieldChangeToPayload(payload, "ndland_considerationoffer", considerationOffer, true);
            _addFieldChangeToPayload(payload, "ndland_assignmentreason", assignmentType, true);
            _addFieldChangeToPayload(payload, "ndland_proposedminingarea", $("#ndland_proposedminingarea").val() !== "placeholder" ? $("#ndland_proposedminingarea").val() : null, true);
            _addFieldChangeToPayload(payload, "ndland_portaldata", portalData, true);
            _addFieldChangeToPayload(payload, "ndland_otherassignees", otherAssignees, true);
            _addFieldChangeToPayload(payload, "ndland_relationshiptocurrentlessee", relationshipToCurrentLessee, true);
            _addFieldChangeToPayload(payload, "ndland_rightofwayreleasetype", rightOfWayReleaseType, true);
            _addFieldChangeToPayload(payload, "ndland_applicationcomments", applicationComments, true);
            _addFieldChangeToPayload(payload, "ndland_aggregateleasetotalreservevolume", estimatedAcresReserve, true);
            _addFieldChangeToPayload(payload, "ndland_aggregateleaseestimatedacres", estimatedAcres, true);
            _addFieldChangeToPayload(payload, "ndland_spacingdescription", spacingDescription, true);
            _addFieldChangeToPayload(payload, "ndland_ndicspacingordernum", ndicSpacingOrder, true);
            _addFieldChangeToPayload(payload, "ndland_wellspuddate", $("#ndland_wellspuddate").val(), true);
            _addFieldChangeToPayload(payload, "ndland_expectedcompletiondate", $("#ndland_expectedcompletiondate").val(), true);
            _addFieldChangeToPayload(payload, "ndland_effectivestartdate", effectiveStartDate, true);
            _addFieldChangeToPayload(payload, "ndland_effectiveenddate", effectiveEndDate, true);
            _addFieldChangeToPayload(payload, "ndland_expectedlastproductiondate", expectedLastProductionDate, true);
            _addFieldChangeToPayload(payload, "ndland_expectedreturntoproductiondate", expectedReturnToProductionDate, true);
            _addFieldChangeToPayload(payload, "ndland_datetreated", $("#ndland_datetreated").val(), true);
            _addFieldChangeToPayload(payload, "ndland_laborcostperhour", Number($("#ndland_laborcostperhour").val()), true);
            _addFieldChangeToPayload(payload, "ndland_numoflaborhours", Number($("#ndland_numoflaborhours").val()), true);
            _addFieldChangeToPayload(payload, "ndland_laborcostperacre", Number($("#ndland_laborcostperacre").val()), true);
            _addFieldChangeToPayload(payload, "ndland_numbofsignsrequested", numberOfSignsRequested, true);
            _addFieldChangeToPayload(payload, "ndland_numprivateacresinpasture", isNaN(parseFloat($("#ndland_numprivateacresinpasture").val())) ? null : parseFloat($("#ndland_numprivateacresinpasture").val()), true);
            _addFieldChangeToPayload(payload, "ndland_landusagecomments", $("#ndland_landusagecomments").val(), true);
            _addFieldChangeToPayload(payload, "ndland_livestockinpasturecomments", $("#ndland_livestockinpasturecomments").val(), true);
            _addFieldChangeToPayload(payload, "ndland_landfencedcomments", $("#ndland_landfencedcomments").val(), true);
            _addFieldChangeToPayload(payload, "ndland_productstobeusedfortreatment", $("#ndland_productstobeusedfortreatment").val(), true);
            _addFieldChangeToPayload(payload, "ndland_totalproductcost", Number(($("#ndland_totalproductcost").val() || "0").replace(/[$,]/g, "")), true);
            _addFieldChangeToPayload(payload, "ndland_projecttotalcost", parseFloat(($("#ndland_projecttotalcost").val() || "0").replace(/[$,]/g, "")), true);
            _addFieldChangeToPayload(payload, "ndland_totallaborcost", Number(($("#ndland_totallaborcost").val() || "0").replace(/[$,]/g, "")), true);
            _addFieldChangeToPayload(payload, "ndland_numofacrestreated", Number($("#ndland_numofacrestreated").val()), true);
            _addFieldChangeToPayload(payload, "ndland_equipmentused", $("#ndland_equipmentused").val(), true);
            _addFieldChangeToPayload(payload, "ndland_percentageofassignorsinterest", Number($("#ndland_percentageofassignorsinterest").val()?.replace("%","")) / 100, true);
            _addFieldChangeToPayload(payload, "ndland_depthsassigned", $("#ndland_depthsassigned").val(), true);
            _addFieldChangeToPayload(payload, "ndland_reasonforshutin", reasonForShutIn, true);

            payload["ndland_agreetoterms"] = termsConditions;

            _addFieldChangeToPayload(payload, "ndland_TractId@odata.bind", `/${$("#ndland_tractid_entityname").val()}s(${$("#ndland_tractid").val()})`, $("#ndland_tractid").val());
            _addFieldChangeToPayload(payload, "ndland_ImprovementTypeId@odata.bind", `/eyland_improvementtypes(${improvementTypeId})`, improvementTypeId);
            _addFieldChangeToPayload(payload, "ndland_SignPostTypeId@odata.bind", `/${$("#ndland_signposttypeid_entityname").val()}s(${signPostTypeId})`, signPostTypeId);
            _addFieldChangeToPayload(payload, nominatorKey, `/${$("#ndland_nominatorid_entityname").val()}s(${nominatorId})`, nominatorId);
            _addFieldChangeToPayload(payload, "ndland_LeaseId@odata.bind", `/eyland_leaseagreements(${leaseAgreementId})`, leaseAgreementId);
            _addFieldChangeToPayload(payload, "ndland_ApplicationTypeId@odata.bind", `/ndland_applicationtypes(${applicationType})`, applicationType);
            _addFieldChangeToPayload(payload, permitteeKey, `/${$("#ndland_permitteeid_entityname").val()}s(${permitteeId})`, permitteeId);
            _addFieldChangeToPayload(payload, requestedOnBehalfOfKey, `/${$("#ndland_requestedonbehalfofid_entityname").val()}s(${requestedOnBehalfOfId})`, requestedOnBehalfOfId);
            _addFieldChangeToPayload(payload, "ndland_PrimaryRightofWayContactId@odata.bind", `/${$("#ndland_primaryrightofwaycontactid_entityname").val()}s(${primaryRightOfWayContactId})`, primaryRightOfWayContactId);
            _addFieldChangeToPayload(payload, "ndland_FinalSignatureContactId@odata.bind", `/${$("#ndland_finalsignaturecontactid_entityname").val()}s(${finalSignatureContactId})`, finalSignatureContactId);
            _addFieldChangeToPayload(payload, "ndland_ConstructionSupervisorId@odata.bind", `/${$("#ndland_constructionsupervisorid_entityname").val()}s(${constructionSupervisorId})`, constructionSupervisorId);
            _addFieldChangeToPayload(payload, "ndland_ConstructionContractorId@odata.bind", `/${$("#ndland_constructioncontractorid_entityname").val()}s(${constructionContractorId})`, constructionContractorId);
            _addFieldChangeToPayload(payload, finalDocumentRecipientKey, `/${$("#ndland_finaldocumenttobemailedtoid_entityname").val()}s(${finalDocumentRecipientId})`, finalDocumentRecipientId);
            _addFieldChangeToPayload(payload, "ndland_ReclamationSupervisorId@odata.bind", `/${$("#ndland_reclamationsupervisorid_entityname").val()}s(${reclamationSupervisorId})`, reclamationSupervisorId);
            _addFieldChangeToPayload(payload, surveyKey, `/${$("#ndland_surveyengineeringcustomerid_entityname").val()}s(${surveyEngineeringCompanyId})`, surveyEngineeringCompanyId);
            _addFieldChangeToPayload(payload, assignorKey, `/${$("#ndland_assignorid_entityname").val()}s(${assignorId})`, assignorId);
            _addFieldChangeToPayload(payload, "ndland_RequestedById@odata.bind", `/contacts(${requestedById})`, requestedById);
            _addFieldChangeToPayload(payload, assigneeKey, `/${$("#ndland_assigneeid_entityname").val()}s(${assigneeId})`, assigneeId);
            _addFieldChangeToPayload(payload, "ndland_RightofWayId@odata.bind", `/eyland_rightofwaies(${rightOfWayId})`, rightOfWayId);
            _addFieldChangeToPayload(payload, granteeKey, `/${$("#ndland_granteecustomerid_entityname").val()}s(${granteeId})`, granteeId);

            return payload;
        };

        var saveApplication = async (isSubmitted, isWithdrawn, contactId, applicationType, applicationId, removedApplications) => {
            $("#formLoaderLoading").show();
            let isUpdate = applicationId && applicationId !== 'null' && applicationId !== '';
            let url = isUpdate
                ? "/_api/eyland_applications(" + applicationId + ")"
                : "/_api/eyland_applications";

            let type = isUpdate ? "PATCH" : "POST";
            let contentType = "application/json";

            let payload = buildPayload(contactId, applicationType);
            if (isSubmitted) {
                var today = new Date();
                var dd = String(today.getDate()).padStart(2, '0');
                var mm = String(today.getMonth() + 1).padStart(2, '0');
                var yyyy = today.getFullYear();
                today = mm + '/' + dd + '/' + yyyy;
                payload["ndland_dateofapplication"] = today;
                payload["statuscode"] = 1;
            }

            if (isWithdrawn) {
                payload["statecode"] = 1;
                payload["statuscode"] = 769150006;
            }

            if (!isUpdate) {
                payload["ndland_requestedon"] = new Date();
            }

            ND.Portal.API.appAjax('Saving record...', {
                type: type,
                url: url,
                contentType: contentType,
                data: JSON.stringify(payload),
                success: async function (res, status, xhr) {
                    clearIsDirty();
                    //disableButtons();
                    let locationHeader = xhr.getResponseHeader('Location');
                    if (isWithdrawn) {
                        $("#formLoaderLoading").hide();
                        $('#withdraw-complete-modal').modal('show');
                        return;
                    }
                    initializeFormValues();
                    await _deleteRemovedApplications(removedApplications);
                    if (locationHeader) {
                        let matches = locationHeader.match(/\(([^)]+)\)/);
                        if (matches) {
                            let newApplicationId = matches[1];
                            var newUrl = new URL(window.location.href);
                            newUrl.searchParams.set('id', newApplicationId);
                            window.history.replaceState(null, null, newUrl.toString());
                            _handleApplicationFileSave(newApplicationId).then(x => {
                                $("#formLoaderLoading").hide();
                                $("#file-data-hdn").val(null);
                                if (isSubmitted) {
				                    //save newApplicationId to session storage for payment modal on reload
                                    sessionStorage.setItem("submittedApplication", newApplicationId);

                                    location.reload();
                                }
                            });
                        } else {
                            $("#formLoaderLoading").hide();
                            //location.reload();
                        }
                    } else {
                        $("#formLoaderLoading").hide();
                        //location.reload();
                    }
                },
                error: function (xhr, status, error) {
                    var errorMessage = xhr.status + ': ' + xhr.statusText;
                    console.log(errorMessage);
                }
            });
        };

        var _deleteRemovedApplications = async (removedApplications) => {
            for (let i = 0; i < removedApplications.length; i++) {
                const removedApplicationId = removedApplications[i].id;
                const removedApplicationName = removedApplications[i].name;
                await _handleApplicationFileDelete(removedApplicationId);
                let fileInput = $("#file-data-hdn").val();
                fileInput = fileInput ? JSON.parse(fileInput) : [];
                const indexToRemove = fileInput.findIndex(x => x.name === removedApplicationName);
                if (indexToRemove !== -1) {
                    fileInput.splice(indexToRemove, 1);
                }     
                $("#file-data-hdn").val(JSON.stringify(fileInput));
                removedApplications.splice(i, 1);
                i--;
            }
        }

        var initializeFormValues = () => {
            document.querySelectorAll('input[type="text"], input[type="date"]').forEach(input => {
                initialApplicationFormFieldValues[input.id] = input.value;
            });
        }
        var saveApplicationAsDraft = async (contactId, applicationId, applicationType, removedApplications) => await saveApplication(false, false, contactId, applicationType, applicationId, removedApplications);

        var saveApplicationAsSubmitted = async (contactId, applicationId, applicationType, removedApplications) => await saveApplication(true, false, contactId, applicationType, applicationId, removedApplications);

        var saveApplicationAsWithdrawn = async (contactId, applicationId, applicationType) => await saveApplication(false, true, contactId, applicationType, applicationId);

        //modal related
        var copyAndUpdateRecords = (keyName, isRemoval) => {
            // Parse the JSON data from the hidden input
            
            if (!isRemoval) {
                let _data = JSON.parse($("#ndland_portaldata").val() || '{}');
                const sourceObj = _data.intersects?.find(item => item.intersectLogicalName === `${keyName}count`);
            
                if (sourceObj) {
                    let targetObj = _data.intersects?.find(item => item.intersectLogicalName === keyName);
                    if (!targetObj) {
                        targetObj = {
                            intersectLogicalName: keyName,
                            records: []
                        };
                        _data.intersects.push(targetObj);
                    } 
                    // First, copy attributes from targetObj into sourceObj if they exist in sourceObj (scenarios when you add additional land units with edtiable values that you don't want erased)
                    targetObj.records.forEach(targetRecord => {
                        let sourceRecord = sourceObj.records.find(record => record.id === targetRecord.id);
                        if (sourceRecord) {
                            Object.assign(sourceRecord, targetRecord);
                        }
                    });
            
                    // Perform a delta copy of records from sourceObj to targetObj (i.e. copy new selected records to subgrid)
                    sourceObj.records.forEach(sourceRecord => {
                        let targetRecord = targetObj.records.find(record => record.id === sourceRecord.id);
                        if (targetRecord) {
                            Object.assign(targetRecord, sourceRecord);
                        } else {
                            targetObj.records.push(sourceRecord);
                        }
                    });
                    $("#ndland_portaldata").val(JSON.stringify(_data));
                }
            } else if (!keyName.includes("count")) {
                //remove records that were deleted from count to main intersect
                let _data = JSON.parse($("#ndland_portaldata").val() || '{}');
                let sourceToRemoveFrom = keyName + "count";
                const sourceObj = _data.intersects?.find(item => item.intersectLogicalName === `${sourceToRemoveFrom}`);

                if (sourceObj) {
                    let targetObj = _data.intersects?.find(item => item.intersectLogicalName === keyName);

                    if (!targetObj) {
                        targetObj = {
                            intersectLogicalName: keyName,
                            records: []
                        };
                        _data.intersects.push(targetObj);
                    }

                    // Perform a full copy of records from sourceObj to targetObj
                    targetObj.records = [...sourceObj.records];
                    $("#ndland_portaldata").val(JSON.stringify(_data));
                } else {
                    let targetObj = _data.intersects?.find(item => item.intersectLogicalName === keyName);
                    if (targetObj) {
                        targetObj.records = [];
                        $("#ndland_portaldata").val(JSON.stringify(_data));
                    }
                }
            } else {
                let _data = JSON.parse($("#ndland_portaldata").val() || '{}');
                let sourceToRemoveFrom = keyName.replace("count", "");
                const sourceObj = _data.intersects?.find(item => item.intersectLogicalName === `${sourceToRemoveFrom}`);

                if (sourceObj) {
                    let targetObj = _data.intersects?.find(item => item.intersectLogicalName === keyName);

                    if (!targetObj) {
                        targetObj = {
                            intersectLogicalName: keyName,
                            records: []
                        };
                        _data.intersects.push(targetObj);
                    }

                    // Perform a full copy of records from sourceObj to targetObj
                    targetObj.records = [...sourceObj.records];
                    $("#ndland_portaldata").val(JSON.stringify(_data));
                } else {
                    let targetObj = _data.intersects?.find(item => item.intersectLogicalName === keyName);
                    if (targetObj) {
                        targetObj.records = [];
                        $("#ndland_portaldata").val(JSON.stringify(_data));
                    }
                }
            }
        }


        var readIntersectSubgrid = async (intersectName, tableName, createRowFunction, postProcessingCallback) => {
            const tableMappings = {
                "ndland_applicationleaseagreement": { nameKey: "LeaseAgreementName", idKey: "LeaseAgreementId" },
                "ndland_applicationleaseagreementcount": { nameKey: "LeaseAgreementName", idKey: "LeaseAgreementId" },
                "ndland_applicationtract": { nameKey: "TractName", idKey: "TractId" },
                "ndland_applicationtractcount": { nameKey: "TractName", idKey: "TractId" },
                "ndland_applicationlandunit": { nameKey: "LandUnitName", idKey: "LandUnitId" },
                "ndland_applicationlandunitcount": { nameKey: "LandUnitName", idKey: "LandUnitId" },
                "ndland_applicationaggregatetype": { nameKey: "AggregateTypeName", idKey: "AggregateTypeId" },
                "ndland_applicationassignee": { nameKey: "AssigneeName", idKey: "AssigneeId" },
                "ndland_applicationassigneecount": { nameKey: "AssigneeName", idKey: "AssigneeId" },
                "ndland_applicationwell": { nameKey: "WellName", idKey: "WellId" },
                "ndland_applicationwellcount": { nameKey: "WellName", idKey: "WellId" },
                "ndland_applicationweedpest": { nameKey: "ProductName", idKey: "ProductId" },
                "ndland_applicationweedpestcount": { nameKey: "ProductName", idKey: "ProductId" }
            };

            let tableKeys = tableMappings[intersectName];

            if (!$("#ndland_portaldata").val()) return;
            if (!tableKeys) return;

            let portalData = JSON.parse($("#ndland_portaldata").val());
            let rootIndex = portalData.intersects.findIndex(x => x.intersectLogicalName == intersectName);
            if (rootIndex !== -1) {
                let itemList = portalData.intersects[rootIndex].records;
                itemList = _handleDefaultSubgridSorting(itemList, intersectName);
                if (itemList.length > 0) {
                    var noResultsMessage = `#${tableName}Table .empty-message`;
                    $(noResultsMessage).hide();
                    $(`#${tableName}-count`).removeClass("hidden");
                }
                let total = 0;
                for (var i = 0; i < itemList.length; i++) {
                    let item = itemList[i];
                    let id = item.id;
                    let name = item.name;
                    let result = {
                        [tableKeys.nameKey]: item.name,
                        [tableKeys.idKey]: item.id,
                        TotalRecordCount: itemList.length
                    };

                    if (intersectName === "ndland_applicationleaseagreement" || intersectName === "ndland_applicationleaseagreementcount") {
                        result.ExpirationDate = item.ExpirationDate;
                        result.PrimaryLessee = item.PrimaryLessee;
                        result.AnnualRent = item.AnnualRent;
                        result.LeasedAcres = item.LeasedAcres;
                        result.Depth = item.Depth;
                        result.PercentOwnership = item.PercentOwnership;

                        total += Number(result.PercentOwnership);
                    }
                    if (intersectName === "ndland_applicationwell" || intersectName === "ndland_applicationwellcount") {
                        result.APINumber = item.APINumber;
                        result.NDICFileNumber = item.NDICFileNumber;
                    }
                    if (intersectName === "ndland_applicationlandunit" || intersectName === "ndland_applicationlandunitcount" || intersectName === "ndland_applicationtract" || intersectName === "ndland_applicationtractcount") {
                        result.ndland_nominatorogbidperacre = item.ndland_nominatorogbidperacre;
                        result.annualRent = item.ndland_nominatorcoaldelayrentalacreperyear;
                        result.bonusPerAcre = item.ndland_nominatorcoalbidperacre;
                        result.royalty = item.ndland_nominatorcoalroyaltyperton;
                        result.lease = item.ndland_nominatorcoalterm;
                        result.LeaseNum = item.LeaseNum;
                        result.EstAcres = item.ndland_estimatedacres || "";

                        total += Number(result.EstAcres);
                    }

                    if (intersectName == "ndland_applicationweedpest") {
                        result.ProductName = item.ndland_weedpestcontroltypeidname || "";
                        result.Cost = item.ndland_controlcost || "";
                        result.Quantity = item.ndland_controlunitamount || "";
                        result.Unit = item.ndland_controlunittype || "";
                        result.Rate = item.ndland_costperacre || "";
                    }
                    if (intersectName == "ndland_applicationassignee" || intersectName == "ndland_applicationassigneecount") {
                        result.PercentAssigned = item.ndland_workinginterestassigned;
                    }
                    if (intersectName === "ndland_applicationtractcount" ||
                        intersectName === "ndland_applicationwellcount" ||
                        intersectName === "ndland_applicationleaseagreementcount" ||
                        intersectName.includes("ndland_applicationlandunit")) {

                        if (createRowFunction) {
                            var rowHtml = createRowFunction(result, true);
                            $(`#${tableName}Table`).find("tbody").append(rowHtml);
                        }
                    }
                    else {
                        if (createRowFunction) {
                            var rowHtml = createRowFunction(result);
                            $(`#${tableName}Table`).find("tbody").append(rowHtml);
                        }
                    }
                }
                if (postProcessingCallback) {
                    if (postProcessingCallback.name === "addWeedAndPestSubgridField") {
                        await postProcessingCallback();
                    } else {
                        postProcessingCallback(total);
                    }
                }
            } else {
                var noResultsMessage = `#${tableName}Table .empty-message`;
                $(noResultsMessage).hide();
                var loader = `#${tableName}Loading`;
                $(loader).hide();
            }
        }

        var _handleDefaultSubgridSorting = (portalDataRecords, intersectName) => {
            if (intersectName === "ndland_applicationtractcount") {
                portalDataRecords.sort(function (a, b) {
                    let nameA = a.name.toUpperCase();
                    let nameB = b.name.toUpperCase();

                    if (nameA < nameB) {
                        return -1;
                    }
                    if (nameA > nameB) {
                        return 1;
                    }
                    return 0;
                });
            } else if (intersectName === "ndland_applicationleaseagreementcount") {
                portalDataRecords.sort(function (a, b) {
                    let nameA = a.name.toUpperCase();
                    let nameB = b.name.toUpperCase();

                    if (nameA < nameB) {
                        return -1;
                    }
                    if (nameA > nameB) {
                        return 1;
                    }
                    return 0;
                });
            } else if (intersectName === "ndland_applicationwellcount") {
                portalDataRecords.sort(function (a, b) {
                    let nameA = a.name.toUpperCase();
                    let nameB = b.name.toUpperCase();

                    if (nameA < nameB) {
                        return -1;
                    }
                    if (nameA > nameB) {
                        return 1;
                    }
                    return 0;
                });
            }
            return portalDataRecords;
        }

        var readIntersectDropdown = (intersectName, tableName) => {
            const tableMappings = {
                "ndland_applicationleaseagreement": { nameKey: "LeaseAgreementName", idKey: "LeaseAgreementId" },
                "ndland_applicationtract": { nameKey: "TractName", idKey: "TractId" },
                "ndland_applicationlandunit": { nameKey: "LandUnitName", idKey: "LandUnitId" },
                "ndland_applicationaggregatetype": { nameKey: "AggregateTypeName", idKey: "AggregateTypeId" }
            };
            let tableKeys = tableMappings[intersectName];

            if (!$("#ndland_portaldata").val()) return;
            if (!tableKeys) return;

            let portalData = JSON.parse($("#ndland_portaldata").val());
            let rootIndex = portalData.intersects.findIndex(x => x.intersectLogicalName == intersectName);
            var selectedItems = [];
            if (rootIndex !== -1) {
                let itemList = portalData.intersects[rootIndex].records;
                for (var i = 0; i < itemList.length; i++) {
                    let item = itemList[i];
                    let id = item.id;
                    $(`#${id}`).prop('selected', true);
                    selectedItems.push(id);
                }
            }
            return selectedItems;
        }

        var loadMultiselectData = (field) => {
            let multiselectsData = ND.Portal.Utilities.getPortalDataProperty('multiselects');
            if (multiselectsData && Object.keys(multiselectsData).length > 0) {
                return multiselectsData[field] || '';
            } else {
                return "{}";
            }
        }

        var saveMultiselectData = (field, data) => {
            let multiselectsData = ND.Portal.Utilities.getPortalDataProperty('multiselects');
            multiselectsData[field] = data;
            ND.Portal.Utilities.setPortalDataProperty('multiselects', multiselectsData);
        }

        //modal related
        var resetModalSelectionsToSelected = (keyName) => {
            let _data = JSON.parse($("#ndland_portaldata").val() || '{}');
            const sourceObj = _data.intersects?.find(item => item.intersectLogicalName === `${keyName}`);

            if (sourceObj) {
                let targetObj = _data.intersects?.find(item => item.intersectLogicalName === keyName);

                if (!targetObj) {
                    targetObj = {
                        intersectLogicalName: keyName,
                        records: []
                    };
                    _data.intersects.push(targetObj);
                }

                // Perform a full copy of records from sourceObj to targetObj
                targetObj.records = [...sourceObj.records];
                $("#ndland_portaldata").val(JSON.stringify(_data));
            }
        }


        var loadRemovalLookupIcons = () => {
            $("input[id$='entityname']").each(function () {
                if ($(this).val()) {
                    var removalButton = `clear-${$(this).attr("id").replace("_entityname", "")}`;
                    $(`#${removalButton}`).removeClass("hidden");
                }
            })
        }

        const populateFieldDescriptions = (applicationType, _handleDescriptionsPostback) => {
			ND.Portal.API.handleApiRequest(`/Services?name=ND Service: Populate Application Type Form Descriptions&applicationType=${applicationType}`, ND.Portal.Forms.populateFormFieldCallback, _handleDescriptionsPostback);
        }

        var populateFormFieldCallback = (result) => {
            var nameSplit = result.snippetName.split('/');
            if (nameSplit.length !== 4)
            {
                console.log('content snippet name does not match expected format', result.snippetName);
                return;
            }
            if (!result.fieldDescriptionValue) {
                return;
            }
            var field = nameSplit[2];
            var tagType = nameSplit[3].replace('Description', '');

            switch (tagType) {
                case 'Section':
                    populateFormFieldDescription('h2', field, result.fieldDescriptionValue, false);
                    $(`fieldset[aria-label="${field}"] .section-description`).insertAfter(`fieldset[aria-label="${field}"] .section-header`);
                    return;
                case 'Field':
                    populateFormFieldDescription(result.tag, field, result.fieldDescriptionValue, false);
                    return;
            }
        }
        
        var populateFormFieldDescription = function (tagName, field, textValue, boldenText, isParent) {
            if (isParent) {
                $(`${tagName}:contains('${field}')`).parent().after(`<p class="help-block ${boldenText ? 'font-weight-bold' : ''}" >${textValue}</p>`);
            } else if ((tagName == 'h3' || tagName == 'h2') && field != "Other Comments") {
                $(`h2:contains('${field}')`).after(`<p class="section-description ${boldenText ? 'font-weight-bold' : ''}" >${textValue}</p>`);
                $(`h3:contains('${field}')`).after(`<p class="section-description ${boldenText ? 'font-weight-bold' : ''}" >${textValue}</p>`);
                $(`h4:contains('${field}')`).after(`<p class="section-description ${boldenText ? 'font-weight-bold' : ''}" >${textValue}</p>`);
            } else if (field == "Other Comments") {
                var _fieldset = $('fieldset[aria-label="Other Comments"]');
                var _helpBlockText = textValue;
                if (_fieldset.find('.info .help-block').length === 0) {
                    $(`label[for='ndland_applicationcomments']`).after(`<p class="help-block ${boldenText ? 'font-weight-bold' : ''}" >${textValue}</p>`);
                }
                else {
                    _fieldset.find('.info .help-block').text(_helpBlockText);
                }
            } else if (field == "Other Comments O&G") {
                $(`${tagName}:contains('${field.replace(" O&G", "")}')`).after(`<p class="help-block ${boldenText ? 'font-weight-bold' : ''}" >${textValue}</p>`);
                $("label.field-label:contains('Other Comments')").remove();
            } else if (field == "Relationship to Primary Lessee") {
                $(`${tagName}:contains('${field}')`).first().after(`<p class="help-block ${boldenText ? 'font-weight-bold' : ''}" >${textValue}</p>`);
            } else if (field == "Primary Lessee") {
                $(`${tagName}:contains('${field}')`).last().after(`<p class="help-block ${boldenText ? 'font-weight-bold' : ''}" >${textValue}</p>`);
            } else {
                if ($(`#${field}`).parents('td').length === 0) {
                    $(`label[for='${field}']`).after(`<p class="help-block ${boldenText ? 'font-weight-bold' : ''}" >${textValue}</p>`);
                }
                else {
                    $(`#${field}`).parents('td').find('label').first().after(`<p class="help-block ${boldenText ? 'font-weight-bold' : ''}" >${textValue}</p>`);
                }
            }
        }

        var replaceSelectedRadioLabel = (containerId, labelToReplace) => {
            var selectedRadio = $(`${containerId} input[type="radio"][disabled]:checked`);
            if (selectedRadio.length) {
                var selectedLabel = $(`label[for="${selectedRadio.attr('id')}"]`).text().trim().replace(labelToReplace, "");
                var selectedText = `<p>${selectedLabel}</p>`;
                $(containerId).replaceWith(selectedText);
            }
        }

        var resetFilterBar = (handlePageToggle, filterType, searchClicked, anyVisible, selector) => {
            $(`${selector} .form-layout select, ${selector} .form-layout input`).not("#openingBidPerAcre-input, #update-request-modal select, #update-request-modal input").each(function () {
                $(this).val('');
            });
            $(`#${filterType}-reset-btn`).removeClass('visible');
            $("#my-tractrecords-btn").addClass("active");
            $("#all-tractrecords-btn").removeClass("active");
            searchClicked = false;
            anyVisible = false;
            handlePageToggle(1);
        }

        var updateSectionTitles = () => {
            $('h3:contains("Project Details")').replaceWith('<h2>Project Details</h2>');
            $('h3:contains("Contacts")').replaceWith('<h2>Contacts</h2>');
            $('h3:contains("Documents")').replaceWith('<h2>Documents</h2>');
            $('h3:contains("Other Comments")').replaceWith('<h2>Other Comments</h2>');
            $('h3:contains("Agreement Details")').replaceWith('<h2>Agreement Details</h2>');
            $('h3:contains("Tracts for Amendment")').replaceWith('<h2>Tracts for Amendment</h2>');
            $('h3:contains("Amendment Details")').replaceWith('<h2>Amendment Details</h2>');

            // move other comments description globally
            var $fieldset = $('fieldset[aria-label="Other Comments"]');
            var helpBlockText = $fieldset.find('legend .help-block').text();
            $fieldset.find('.info .help-block').text(helpBlockText);
        }

        var findRecordById = (intersectLogicalName, recordId) => {
            const data = JSON.parse($("#ndland_portaldata").val() || "{}");
            const intersectObj = data?.intersects?.find(intersect => intersect.intersectLogicalName === intersectLogicalName);
            if (intersectObj) {
                const record = intersectObj.records.find(record => record.id === recordId);
                return record ? record : null;
            }
            return null;
        }


        var updateModalSelectedCount = (modalName, subgridName, intersectName, logicalName) => {
            let _data;
            const selectedCount = $(`#${modalName} input[type='checkbox']:checked`);
            selectedCount.each(function (index) {
                _data = ND.Portal.API.writeIntersectSubgrid(index, subgridName, intersectName, logicalName, $(this), [], null);
                $("#ndland_portaldata").val(JSON.stringify(_data));
            });

            const intersectObj = _data?.intersects.find(item => item.intersectLogicalName === intersectName);
            
            let parentModalName = $(`#${modalName}`).closest(".modal").attr("id");
            let totalCount = intersectObj ? intersectObj.records.length : 0;
            setModalSelectedCount(parentModalName, totalCount);
        }

        var setModalSelectedCount = (modalName, totalCount) => {
            if (totalCount > 0) {
                $(`#${modalName} .label.label-primary`).text(`${totalCount} selected`);
                $(`#${modalName} .label.label-primary`).removeClass("hidden");
            } else {
                $(`#${modalName} .label.label-primary`).addClass("hidden");
            }
        }

        var saveModalSelection = (tableName, selectedRow, selectionArr) => {
            const currentLookupValue = $(`#${tableName}`).attr("currentlookupvalue");
            const newEntry = `${currentLookupValue}:${selectedRow.find("input[type='radio']").attr("id")}`;
            selectionArr = selectionArr.filter(entry => !entry.startsWith(`${currentLookupValue}:`));
            selectionArr.push(newEntry);
            return selectionArr;
        }


        var removeRowFromJsonData = (row, intersectName) => {
            let _data = JSON.parse($("#ndland_portaldata").val() || '{}');
            const intersectObj = _data.intersects.find(item => item.intersectLogicalName === intersectName);
            if (intersectObj) {
                let recordName = row.find("input[type='checkbox']").val();
				if (!recordName) {
					recordName = row.val();
				}
                // Remove the record from the JSON data
                intersectObj.records = intersectObj.records.filter(record => record.name !== recordName);
                $("#ndland_portaldata").val(JSON.stringify(_data));
            }
        }

        var transformAgreeToTerms = (applicationType) => {
            var $container = $('#ndland_agreetoterms');
            var agreeToTermsValue = $("#ndland_agreetoterms :checked").val();
            $('#ndland_agreetoterms_label').hide();
            // Replace the radio buttons with a single checkbox
            // if (applicationType === "reimbursement") {
            //     $container.html(`
			// 		<div class="checkbox">
			// 			<label>
			// 				<input id="ndland_agreetoterms_checkbox" name="checkbox" type="checkbox" name="ndland_agreetoterms" value="1">
			// 				<span class="ui"></span>
			// 				Agree to Terms
			// 			</label>
			// 		</div>`);
            // } else if (applicationType === "preapproval") {
            //     $container.html(`
			// 		<div class="checkbox">
			// 			<label>
			// 				<input id="ndland_agreetoterms_checkbox" name="checkbox" type="checkbox" name="ndland_agreetoterms" value="1">
			// 				<span class="ui"></span>
			// 				Agree to Terms
			// 			</label>
			// 		</div>`);
            // } else {
                $container.html(`
					<div class="checkbox">
						<label>
							<input id="ndland_agreetoterms_checkbox" name="checkbox" type="checkbox" name="ndland_agreetoterms" value="1">
							<span class="ui"></span>
								I have read and agree to the 
								<a href="javascript:void(0)" role="menuitem" data-toggle="modal" data-target="#termsandconditionsmodal" class="alert-link" aria-label="Terms & Conditions" >Terms & Conditions</a>.
						</label>
					</div>`);
            // }
            $('fieldset[aria-label="Terms"] > legend').wrap(`
				<div class="section-header section-required">
					<div class="section-title-container"></div>
				</div>`);

            if (agreeToTermsValue === "1") {
                $('#ndland_agreetoterms_checkbox').prop('checked', true);
            }
        }

        var transformSignPostType = () => {
            var signPostType = $('#ndland_signposttypeid');
            var radioWrapper = $('<span id="ndland_signposttypeid_radios" class="boolean-radio" onchange="setIsDirty(this.id);" data-required="true" aria-invalid="true"></span>');
            var radioIdCounter = 0;
            var radios = [];

            signPostType.find('option').each(function () {
                var value = $(this).val();
                var label = $(this).text();

                if (label === 'Closed' || label === 'Notify the Lessee') {
                    var radioId = 'ndland_signposttypeid_' + radioIdCounter++;
                    var radioButton = '<input id="' + radioId + '" type="radio" value="' + value + '" name="ndland_signposttypeid" required="">' +
                        '<label for="' + radioId + '">' +
                        '<span class="ui"></span>' +
                        '<span class="sr-only">Signpost Type</span>' + label +
                        '</label>';
                    // Push to radios array in reverse order to get the buttons to appear in a certain order
                    if (label === 'Notify the Lessee') {
                        radios.unshift(radioButton);
                    } else {
                        radios.push(radioButton);
                    }
                }
            });

            radios.forEach(function (radioButton) {
                radioWrapper.append(radioButton);
            });

            signPostType.replaceWith(radioWrapper);
        };

        return {
            hideSections: hideSections,
            showSections: showSections,
            removeFieldIfBlank: removeFieldIfBlank,
            addLookupButtons: addLookupButtons,
            clonePortalDataToSelectionCounts: clonePortalDataToSelectionCounts,
            populateLookupName: populateLookupName,
            handleLookupPopulation: handleLookupPopulation,
            addSubmissionValidation: addSubmissionValidation,
            copyAndUpdateRecords: copyAndUpdateRecords,
            loadRemovalLookupIcons: loadRemovalLookupIcons,
            populateFieldDescriptions: populateFieldDescriptions,
            populateFormFieldCallback: populateFormFieldCallback,
            populateFormFieldDescription: populateFormFieldDescription,
            saveApplicationAsDraft: saveApplicationAsDraft,
            saveApplicationAsSubmitted: saveApplicationAsSubmitted,
            readIntersectSubgrid: readIntersectSubgrid,
            readIntersectDropdown: readIntersectDropdown,
            loadMultiselectData: loadMultiselectData,
            saveMultiselectData: saveMultiselectData,
            updateSectionTitles: updateSectionTitles,
            findRecordById: findRecordById,
            replaceSelectedRadioLabel: replaceSelectedRadioLabel,
            resetFilterBar: resetFilterBar,
            updateModalSelectedCount: updateModalSelectedCount,
            setModalSelectedCount: setModalSelectedCount,
            saveModalSelection: saveModalSelection,
            removeRowFromJsonData: removeRowFromJsonData,
            transformAgreeToTerms: transformAgreeToTerms,
            transformSignPostType: transformSignPostType
        }
    })();

})(this);